#include <QGuiApplication>
#include <QObject>
#include <QQmlApplicationEngine>
#include <QQmlComponent>
#include <QQmlContext>
#include <csignal>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <sys/prctl.h>
#include <sys/wait.h>
#include <thread>
#include <unistd.h>

#include "qmlhandler.h"

using namespace std;

int main(int argc, char *argv[]) {
  QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);

  // This has to be here to fix warnings
  QCoreApplication::setOrganizationName("CCats");

  QGuiApplication app(argc, argv);

  QQmlApplicationEngine engine;

  QMLHandler qmlHandler;

  engine.rootContext()->setContextProperty("_qmlHandler", &qmlHandler);

  QQmlComponent component(&engine, QUrl(QStringLiteral("qrc:/main.qml")));

  QObject *object = component.create();

  int ret = app.exec();

  qmlHandler.onExit();

  return ret;
}
